#include <jni.h>
#include <android/log.h>
#include "platform/android/jni/JniHelper.h"

// _BQ_TMPL_CONFIGURE_INCLUDE_BEGIN
// _BQ_TMPL_CONFIGURE_INCLUDE_SNSAUTH_BEGIN
#include "Common/UserData/UserDataBridge.h"
#include "Library/UtilityForSakura.h"
#include "Scene/ChangingMobileModel/SnsMobileDataMigration.h"
#include "Scene/ChangingMobileModel/SnsMobileDataMigrationListener.h"
// _BQ_TMPL_CONFIGURE_INCLUDE_SNSAUTH_END
// _BQ_TMPL_CONFIGURE_INCLUDE_END
#include "AppConfigure.h"

extern "C"
{

JNIEXPORT jstring JNICALL Java_jp_co_drecom_util_config_AppConfigure_getWebViewErrorTemplate()
{
	JavaVM* _vm = cocos2d::JniHelper::getJavaVM();
	JNIEnv* _env;
	_vm->GetEnv((void**)&_env, JNI_VERSION_1_4);
	_vm->AttachCurrentThread(&_env, NULL);

	return _env->NewStringUTF(ANDROID_WEBVIEW_ERROR_TEMPLATE);
}

// _BQ_TMPL_CONFIGURE_FUNC_BEGIN
// _BQ_TMPL_CONFIGURE_FUNC_SNSAUTH_BEGIN
jstring Java_jp_co_drecom_util_config_AppConfigure_getUserId(JNIEnv* env, jobject javaThis) {
    long long user_id = UserDataBridge::getInstance()->getUserId();
    std::string user_id_str = UtilityForSakura::bigintToString(user_id);
    return env->NewStringUTF(user_id_str.c_str());
}

JNIEXPORT void JNICALL Java_jp_co_drecom_util_config_AppConfigure_callbackSnsAuthnication(JNIEnv* env, jobject javaThis, jstring jcode, jstring joperation, jstring jtoken, jstring jsns_account) {

  SnsMobileDataMigration* instance = SnsMobileDataMigration::getInstance();

  if (instance != NULL) {
    SnsMobileDataMigrationListener* listener = instance->getListener();
    if (listener != NULL) {
      const char* code  = env->GetStringUTFChars(jcode, 0);
      const char* operation_str  = env->GetStringUTFChars(joperation, 0);
      int operation = atoi( operation_str );
      const char* token = env->GetStringUTFChars(jtoken, 0);
      const char* sns_account = env->GetStringUTFChars(jsns_account, 0);
      listener->onCallBack(code, operation, token, sns_account);
      env->ReleaseStringUTFChars(jcode, code);
      env->ReleaseStringUTFChars(joperation, operation_str);
      env->ReleaseStringUTFChars(jtoken, token);
      env->ReleaseStringUTFChars(jsns_account, sns_account);
    }
  }
  return;
}
// _BQ_TMPL_CONFIGURE_FUNC_SNSAUTH_END
// _BQ_TMPL_CONFIGURE_FUNC_END
}	//  extern "C"
